package ttakada;

import com.idiominc.wssdk.WSContext;
import com.idiominc.wssdk.WSVersion;
import com.idiominc.wssdk.component.WSComponentConfigurationUI;
import com.idiominc.wssdk.component.mt.WSMTAdapterComponent;
import com.idiominc.wssdk.component.mt.WSMTRequest;
import com.idiominc.wssdk.linguistic.WSLanguage;
import com.idiominc.wssdk.linguistic.WSLanguagePair;
import com.idiominc.wssdk.mt.WSMTResult;
import org.apache.log4j.Logger;

import java.util.Locale;

public class MyMTAdapterComponent extends WSMTAdapterComponent {
    private static final Logger log = Logger.getLogger(MyMTAdapterComponent.class);

    @Override
    public String getName() {
        return "My Test MT";
    }

    @Override
    public String getDescription() {
        return "My Test MT";
    }

    @Override
    public String getVersion() {
        return "0.0.0.1";
    }

    @Override
    public WSVersion getMinimumWorldServerVersion() {
        return new WSVersion(10, 3, 0);
    }

    @Override
    public WSComponentConfigurationUI getConfigurationUI() {
        return new MyMTAdapterConfigUI();
    }

    @Override
    public boolean supportsPlaceholders() {
        return true;
    }

    @Override
    public WSLanguagePair[] getSupportedLanguagePairs(WSContext context) {
        WSLanguage LANG_ENGLISH  = context.getLinguisticManager().getLanguage(Locale.US);
        WSLanguage LANG_JAPANESE = context.getLinguisticManager().getLanguage(Locale.JAPAN);

        return new WSLanguagePair[]{
                new WSLanguagePair(LANG_ENGLISH, LANG_JAPANESE)
        };
    }

    @Override
    public void translate(WSContext context, WSMTRequest[] requests, WSLanguage source, WSLanguage target) {
        MyMTAdapterConfigData config = (MyMTAdapterConfigData) getCurrentConfiguration().getConfigurationData();

        for(WSMTRequest request : requests) {
            String text = request.getSource();
            log.warn("SRC: " + text);
            String translation = config.getPrefix() + text + config.getSuffix();

            WSMTResult[] results = new WSMTResult[]{
                    new WSMTResult(text, translation, 100)
            };
            request.setResults(results);
        }
    }
}
