package ttakada;

import com.idiominc.wssdk.WSContext;
import com.idiominc.wssdk.WSException;
import com.idiominc.wssdk.asset.WSAssetTask;
import com.idiominc.wssdk.asset.WSAssetTranslation;
import com.idiominc.wssdk.component.WSParameter;
import com.idiominc.wssdk.component.autoaction.WSActionResult;
import com.idiominc.wssdk.component.autoaction.WSTaskAutomaticAction;
import com.idiominc.wssdk.mt.WSMTService;
import com.idiominc.wssdk.mt.WSMTServiceManager;
import com.idiominc.wssdk.workflow.WSTask;
import org.apache.log4j.Logger;

import java.util.Map;

/**
 * Created by ttakada on 2015/11/10.
 */
public class MyTestAA extends WSTaskAutomaticAction {
    private static final Logger log      = Logger.getLogger(MyTestAA.class);
    private static final double MT_SCORE = 100;

    @Override
    public String getName() {
        return "My Test AA";
    }

    @Override
    public String getDescription() {
        return "This AA applies My MT Adapter translations on segments. ";
    }

    @Override
    public String getVersion() {
        return "0.0.0.0.1";
    }

    @Override
    public String[] getReturns() {
        return new String[]{
                WSActionResult.DONE_RETURN_VALUE,
        };
    }

    @Override
    public WSParameter[] getParameters() {
        return new WSParameter[]{
        };
    }

    @Override
    public WSActionResult execute(WSContext context, Map parameters, WSTask task) throws WSException {
        WSAssetTask        assetTask        = (WSAssetTask) task;
        WSAssetTranslation assetTranslation = assetTask.getAssetTranslation();

        WSMTServiceManager manager       = context.getMTServiceManager();
        String             targetAisPath = assetTask.getTargetPath();
        WSMTService        baseService   = manager.getAssignedMTService(targetAisPath);
        MyMTServiceWrapper service       = new MyMTServiceWrapper(baseService);
        log.warn("MT Service: " + service.getDisplayString());
        log.warn("MT Adapter: " + service.getAdapter().getName());
        log.warn("MT Config: " + service.getCurrentConfiguration().getName());

        service.translate(assetTranslation, MT_SCORE);

        return new WSActionResult(WSActionResult.DONE_RETURN_VALUE, "Finished.");
    }

}
